LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;


entity edge_detection_circuit_tb is
end edge_detection_circuit_tb;


architecture my_tb of edge_detection_circuit_tb is

  component edge_detect_fsm is
    port (
      clk, reset: in std_logic;
      level: in std_logic;
      tick: out std_logic
    );
  end component;

  signal clk_i, reset_i, level_i, tick_o : std_logic; 

  
  begin

  -- (1) instantiate design under test (DUT);
  edge_detect_fsm_DUT : edge_detect_fsm port map (
    clk => clk_i, 
    reset => reset_i, 
    level => level_i, 
    tick => tick_o
  );

  -- (2) process to generate clock signal; let's say we use a clock signal 
  -- with period 100 ns;
  clk_generation : process
  begin
    clk_i <= '1'; wait for 50 ns;
    clk_i <= '0'; wait for 50 ns;
  end process clk_generation;
  
  -- (3) process to generate desired input stimuli;
  dut_inputs_stimuli: process
  begin
    reset_i <= '1';
    level_i <= '0';
    wait for 200 ns;

    reset_i <= '0'; -- stays like this for rest of simulation
    level_i <= '0';
    wait for 200 ns;
    
    level_i <= '0';
    wait for 400 ns;
    
    level_i <= '1';
    wait for 200 ns;
    
    level_i <= '0';
    wait for 400 ns;
  end process dut_inputs_stimuli;
    
end my_tb;
